
/*
 * $Id: WorkSetFreezer.cc,v 1.2 1999/09/17 23:54:23 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "polygraph.h"

#include "LogComment.h"
#include "BcastRcver.h"
#include "WorkSetFreezer.h"

#include "polyBcastChannels.h"


WorkSetFreezer::WorkSetFreezer(Time delay) {
	sleepFor(delay);
}

void WorkSetFreezer::wakeUp(const Alarm &alarm) {
	AlarmUser::wakeUp(alarm);

	Broadcast(TheInfoChannel, BcastRcver::ieWorkSetFreeze);
	Comment(5) << "fyi: working set size is frozen" << endc;
}
