
/*
 * $Id: OidDistr.h,v 1.3 1999/09/07 17:47:10 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef OID_DISTR_H
#define OID_DISTR_H

#include "Rnd.h"

// Object Id distribution
// produces oid stream with a given hit ratio
class OidDistr: public RndDistr {
	public:
		OidDistr(RndGen *aGen, double aHitRatio): RndDistr(aGen), theHitRatio(aHitRatio) {}

		virtual int genOid() = 0;

		virtual double trial() { return genOid(); }

		// these do not make much sense for object ids
		virtual double mean() const { return theHitRatio; }
		virtual double sdev() const { return 0; }

	protected:
		double theHitRatio;
};

#endif
