
/*
 * $Id: SharedOpts.h,v 1.15.2.2 1999/10/23 23:00:55 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef SHARED_OPTS
#define SHARED_OPTS

#include "opts.h"
#include "polyOpts.h"

// options shared by client and server sides
class SharedOpts: public OptGrp {
	public:
		SharedOpts(); // defaults

		virtual bool validate() const;
		
	public:
		HelpOpt theHelpOpt;
		VersionOpt theVersOpt;
		HostTypeOpt theHostTypeOpt;

		IntOpt theVerbLevel;
		DumpFlagsOpt theDumpFlags;
		SizeOpt theDumpSize;
		NetAddrOpt theNotifAddr;
		StrOpt theRunLabel;

		IntOpt theFDLimit;

		StrOpt theCfgFileName;
		StrArrOpt theCfgDirs;

		StrOpt theConsFileName;
		StrOpt theLogFileName;
		SizeOpt theLogSize;
		StrOpt theSmplLogFileName;
		SizeOpt theSmplLogSize;

		TimeOpt theStatCycleLen;

		FileScanOpt theFileScanner;

		IntOpt theNidsPerMsgMax;

		StrArrOpt theFakeHosts;

		TimeOpt theIdleTout;

		IntOpt theRngSeed;
};

extern SharedOpts TheOpts;

#endif
