
/*
 * $Id: StatsSampleMgr.h,v 1.1.2.1 1999/10/23 23:00:56 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_STATS_SAMPLING_MANAGER_H
#define PG_STATS_SAMPLING_MANAGER_H

#include "Array.h"
#include "AlarmClock.h"

class StatsSampleSym;
class StatsSampleCfg;

// schedules an initiates sampling

class StatsSampleMgr: public AlarmUser {
	public:
		StatsSampleMgr();
		virtual ~StatsSampleMgr();

		void configure(const Array<StatsSampleSym*> &cfgs);

		void start();

		virtual void wakeUp(const Alarm &);

		void reportCfg(ostream &os) const;

	protected:
		void startSample();
		void schedSample();

	protected:
		Array<StatsSampleCfg*> theCfgs;
		int theStartCnt;              // how many samples were started
};

#endif
