
/*
 * $Id: ObjLifeCycleSym.h,v 1.3 1999/09/07 17:47:59 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PGL_OBJECT_LIFE_CYCLE_SYMBOL_H
#define PGL_OBJECT_LIFE_CYCLE_SYMBOL_H

#include "Array.h"
#include "PglRecSym.h"

class QualifSym;

// parameters for object life cycle model
class ObjLifeCycleSym: public RecSym {
	public:
		ObjLifeCycleSym();
		ObjLifeCycleSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		RndDistr *bday() const;
		RndDistr *length() const;
		bool variance(double &ratio) const;
		bool withLmt(double &ratio) const;
		bool expires(Array<RndDistr*> &times, RndDistr *&selector, Array<QualifSym*> &qs) const;
};

#endif
