
/*
 * $Id: PglIntSym.h,v 1.6 1999/09/07 17:48:03 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PGL_INT_SYMBOL_H
#define PGL_INT_SYMBOL_H

#include "PglExprSym.h"

class IntSym: public ExpressionSym {
	public:
		static IntSym *Fit(const String &op, double d, const TokenLoc &);

	public:
		IntSym(int aVal);

		int val() const { return theVal; }
		void val(int v) { theVal = v; }

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		virtual ExpressionSym *unOper(const String &op) const;
		virtual ExpressionSym *bnOper(const String &op, const SynSym &exp) const;

		virtual ostream &print(ostream &os, const String &pfx = 0) const;

	protected:
		IntSym *fit(const String &op, double d) const;
		ExpressionSym *operRange(int otherEnd) const;

	protected:
		int theVal;
};

#endif
