
/*
 * $Id: ServerSym.h,v 1.6.2.1 1999/10/25 19:17:41 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_SERVER_SYMBOL_H
#define PG_SERVER_SYMBOL_H

#include "AgentSym.h"

class ContentSym;
class RndDistr;

// server side configuration
class ServerSym: public AgentSym {
	public:
		ServerSym();
		ServerSym(const String aType, PglRec *aRec);

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		bool acceptLmt(int &lmt) const;
		bool contents(Array<ContentSym*> &ccfgs, Array<double> &cprobs) const;
		bool directAccess(Array<ContentSym*> &dacfgs) const;
};

#endif
