
/*
 * $Id: popModels.h,v 1.2 1999/09/17 23:54:58 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PGL_VARIOUS_POP_MODEL_CLASSES_H
#define PGL_VARIOUS_POP_MODEL_CLASSES_H

#include "PopModel.h"

// uniform
class UnifPopModel: public PopModel {
	public:
		// selects oid, honors work set capacity

		virtual ostream &print(ostream &os) const;

	protected:
		virtual int select(RndGen &rng, int lastOid);
};

// zipf power law emulation
class ZipfPopModel: public PopModel {
	public:
		ZipfPopModel(double aSkew = 1);

		virtual ostream &print(ostream &os) const;

	protected:
		virtual int select(RndGen &rng, int lastOid);

	protected:
		double theSkew;
};

#endif
