
/*
 * $Id: fixResourceUsage.cc,v 1.1.2.1 1999/11/08 04:29:30 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "xstd.h"

#include <sys/param.h>  /* for BSD4_4 to be defined */
#include <unistd.h>

#include "fixResourceUsage.h"

Size MaxRss2Size(long maxrss) {
	int kb = -1;
	// some platforms define maxrss in KBytes, some in pages
#if defined(CFG_HOS_SGI)
	kb = maxrss;
#elif defined(CFG_HOS_OSF)
	kb = maxrss;
#elif defined(BSD4_4)
	kb = maxrss;
#elif defined(HAVE_GETPAGESIZE)
	kb = (maxrss * ::getpagesize()) / 1024;
#elif defined(PAGESIZE)
	kb = (maxrss * PAGESIZE) / 1024;
#else
	kb = maxrss;
#endif

	return Size::KB(kb);
}
