
/*
 * $Id: xport.cc,v 1.7 1999/09/07 17:48:33 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "xstd.h"
#include "xport.h"

static time_t fake_timegm(struct tm *t);

#if defined(HAVE_EXTERN_TIMEZONE)
	extern time_t timezone;
#endif


time_t xtimegm(struct tm *t) {
#	ifdef HAVE_TIMEGM
		return timegm(t);
#	else
		return fake_timegm(t);
#	endif
}


static
time_t fake_timegm(struct tm *t) {
	const time_t res = mktime(t);

#	if defined(HAVE_ALTZONE)
		return res - altzone; // Solaris
#	elseif defined(HAVE_TM_GMTOFF)
		const struct tm *local = localtime(&res);
		return res + local->tm_gmtoff;
#	elseif defined(HAVE_TIMEZONE)
		const time_t dst = t->tm_isdst > 0 ? -3600 : 0;
		return res - (xtimezone() + dst);
#	else
		return res;
#	endif
}
